using System;
using System.Threading;

namespace AClient
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Client
	{
		private static bool done = false;
		public static void reportResult(IAsyncResult asyncResult)
		{
			AClient.WeatherInfo.TemperatureProvider obj 
				= (AClient.WeatherInfo.TemperatureProvider) asyncResult.AsyncState;
			Console.WriteLine("Reponse from server {0} received at {1}",
						obj.EndgetInfo(asyncResult), DateTime.Now);
			done = true;
		}

		private static void killTime()
		{
			while(done == false)
			{
				Console.Write(".");
				Thread.Sleep(1000);
			}
		}

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			AClient.WeatherInfo.TemperatureProvider obj = 
				new AClient.WeatherInfo.TemperatureProvider();

			AsyncCallback callback = new AsyncCallback(reportResult);
			IAsyncResult asyncResult = obj.BegingetInfo(callback, obj);

			Console.WriteLine("Request sent! at {0}", DateTime.Now);

			Console.WriteLine("We will let you know when a response arrives");

			new Thread(new ThreadStart(killTime)).Start();
		}
	}
}
